SystemOrganization addCategory: #ConfigurationOfAmberSlime!

Object subclass: #ConfigurationOfAmberSlime
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAmberSlime'!

!ConfigurationOfAmberSlime classSide methodsFor: 'development support' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfAmberSlime classSide methodsFor: 'private' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfAmberSlime classSide methodsFor: 'private' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfAmberSlime classSide methodsFor: 'private' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfAmberSlime classSide methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAmberSlime classSide methodsFor: 'loading' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfAmberSlime classSide methodsFor: 'loading' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfAmberSlime classSide methodsFor: 'loading' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfAmberSlime classSide methodsFor: 'accessing' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
project

	^self new project! !

!ConfigurationOfAmberSlime classSide methodsFor: 'development support' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfAmberSlime methodsFor: 'baselines' stamp: 'PaulDeBruicker 1/12/2012 14:57'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://squeaksource.com/AmberSlime'.
			spec
				project: 'RefactoringBrowser'
				with: [ 
					spec
						className: 'ConfigurationOfRefactoringBrowser';
						versionString: #stable;
						repository: 'http://www.squeaksource.com/MetacelloRepository' ].
			spec
				package: 'Amber-Slime' with: [ spec requires: #('RefactoringBrowser') ];
				package: 'Amber-Tests-Slime' with: [ spec requires: #('Amber-Slime') ].
			spec
				group: 'default' with: #('Amber-Slime');
				group: 'Tests' with: #('Amber-Tests-Slime') ]! !

!ConfigurationOfAmberSlime methodsFor: 'symbolic versions' stamp: 'PaulDeBruicker 1/12/2012 15:00'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfAmberSlime methodsFor: 'accessing' stamp: 'PaulDeBruicker 1/12/2012 14:56'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfAmberSlime methodsFor: 'symbolic versions' stamp: 'PaulDeBruicker 1/12/2012 15:00'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfAmberSlime methodsFor: 'versions' stamp: 'PaulDeBruicker 1/12/2012 15:24'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'initial development version'.
		spec author: 'PaulDeBruicker'.
		spec timestamp: '1/12/2012 14:59'.
		spec project: 'RefactoringBrowser' with: #'stable'.
		spec 
			package: 'Amber-Slime' with: 'Amber-Slime-PaulDeBruicker.1';
			package: 'Amber-Tests-Slime' with: 'Amber-Tests-Slime-PaulDeBruicker.2'. ].
! !
